#! /usr/bin/python3

# required:
# - parted

import os
import random
import shutil
import sys

def get_file_list(source):
    matches = []
    for root, dirnames, filenames in os.walk(source):
        for filename in filenames:
            if filename.lower().endswith(('.mp3',)):
                matches.append(os.path.join(root, filename))
    return matches

image_nr = 0
try:
    os.mkdir('./mnt')
except FileExistsError:
    pass

current_list = []
current_size = 0

all_files = get_file_list(sys.argv[1])
random.shuffle(all_files)

for file in all_files:
    file_stats = os.stat(file)
    file_size = file_stats.st_size

    if current_size + file_size > 950 * 2 * 1024 * 1024:
        img_file = f'image{image_nr:04}'

        # create image file
        open(img_file, 'w').close()
        os.truncate(img_file, 2 * 1024 * 1024 * 1024)
        image_nr += 1

        # prepare image
        os.system(f"echo 'mklabel msdos' | parted {img_file}")
        os.system(f"echo 'mkpart primary 1M 1000M vfat' | parted {img_file}")
        os.system(f"echo 'type 1 c' | parted {img_file}")

        # connect 
        os.system(f'losetup /dev/loop123 {img_file}')
        os.system(f'losetup -o $((2048 * 512)) /dev/loop124 {img_file}')

        # make filesystem
        os.system(f'mkfs.vfat /dev/loop124')

        # mount
        os.system(f'mount /dev/loop124 ./mnt')

        for f in current_list:
            shutil.copyfile(f, './mnt/' + os.path.basename(f))

        os.system('umount ./mnt')
        os.system('losetup -d /dev/loop123')
        os.system('losetup -d /dev/loop124')

        current_list = []
        current_size = 0

    current_list.append(file)
    current_size += file_size
